/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The require scope
/******/ 	var __webpack_require__ = {};
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  ADAPTER_EVENTS: () => (/* reexport */ base_namespaceObject.ADAPTER_EVENTS),
  ADAPTER_STATUS: () => (/* reexport */ ADAPTER_STATUS),
  PASSKEYS_PLUGIN: () => (/* reexport */ PASSKEYS_PLUGIN),
  SDK_MODE: () => (/* reexport */ SDK_MODE),
  TORUS_LEGACY_NETWORK: () => (/* reexport */ external_toruslabs_constants_namespaceObject.TORUS_LEGACY_NETWORK),
  TORUS_SAPPHIRE_NETWORK: () => (/* reexport */ external_toruslabs_constants_namespaceObject.TORUS_SAPPHIRE_NETWORK),
  Web3Auth: () => (/* reexport */ Web3Auth),
  decodeToken: () => (/* reexport */ decodeToken)
});

;// external "@web3auth/base"
const base_namespaceObject = require("@web3auth/base");
;// ./src/constants.ts

const ADAPTER_STATUS = {
  NOT_READY: "not_ready",
  READY: "ready",
  CONNECTED: "connected"
};
const SDK_MODE = {
  REACT_NATIVE: "react-native",
  WEB: "web",
  NODE: "node"
};
const PASSKEYS_PLUGIN = "PASSKEYS_PLUGIN";
;// external "@toruslabs/constants"
const external_toruslabs_constants_namespaceObject = require("@toruslabs/constants");
;// ./src/interface.ts


;// external "@web3auth/auth"
const auth_namespaceObject = require("@web3auth/auth");
;// ./src/utils.ts

function decodeToken(token) {
  const [header, payload] = token.split(".");
  return {
    header: JSON.parse((0,auth_namespaceObject.safeatob)(header)),
    payload: JSON.parse((0,auth_namespaceObject.safeatob)(payload))
  };
}
;// external "@babel/runtime/helpers/objectSpread2"
const objectSpread2_namespaceObject = require("@babel/runtime/helpers/objectSpread2");
var objectSpread2_default = /*#__PURE__*/__webpack_require__.n(objectSpread2_namespaceObject);
;// external "@babel/runtime/helpers/defineProperty"
const defineProperty_namespaceObject = require("@babel/runtime/helpers/defineProperty");
var defineProperty_default = /*#__PURE__*/__webpack_require__.n(defineProperty_namespaceObject);
;// external "@toruslabs/base-controllers"
const base_controllers_namespaceObject = require("@toruslabs/base-controllers");
;// external "@toruslabs/fnd-base"
const fnd_base_namespaceObject = require("@toruslabs/fnd-base");
;// external "@toruslabs/session-manager"
const session_manager_namespaceObject = require("@toruslabs/session-manager");
;// external "@toruslabs/torus.js"
const torus_js_namespaceObject = require("@toruslabs/torus.js");
;// external "bs58"
const external_bs58_namespaceObject = require("bs58");
var external_bs58_default = /*#__PURE__*/__webpack_require__.n(external_bs58_namespaceObject);
;// ./src/asyncStorage.ts

class AsyncStorage {
  constructor(storeKey, storage) {
    defineProperty_default()(this, "storage", void 0);
    defineProperty_default()(this, "_storeKey", void 0);
    this.storage = storage;
    this._storeKey = storeKey;
  }
  async toJSON() {
    if ("getItemAsync" in this.storage) {
      return this.storage.getItemAsync(this._storeKey, {});
    }
    const result = await this.storage.getItem(this._storeKey);
    return result;
  }
  async resetStore() {
    const currStore = await this.getStore();
    await this.setStore({});
    return currStore;
  }
  async getStore() {
    if ("getItemAsync" in this.storage) {
      return JSON.parse((await this.storage.getItemAsync(this._storeKey, {})) || "{}");
    }
    return JSON.parse((await this.storage.getItem(this._storeKey)) || "{}");
  }
  async setStore(store) {
    if ("setItemAsync" in this.storage) {
      return this.storage.setItemAsync(this._storeKey, JSON.stringify(store), {});
    }
    return this.storage.setItem(this._storeKey, JSON.stringify(store));
  }
  async get(key) {
    const store = await this.getStore();
    return store[key];
  }
  async set(key, value) {
    const store = await this.getStore();
    store[key] = value;
    return this.setStore(store);
  }
  async remove(key) {
    const store = await this.getStore();
    delete store[key];
    return this.setStore(store);
  }
}
;// ./src/Web3Auth.ts













class Web3Auth extends auth_namespaceObject.SafeEventEmitter {
  constructor(options) {
    var _options$chainConfig, _options$privateKeyPr, _options$chainConfig2, _options$useDkg;
    super();
    defineProperty_default()(this, "coreOptions", void 0);
    defineProperty_default()(this, "connectedAdapterName", base_namespaceObject.WALLET_ADAPTERS.SFA);
    defineProperty_default()(this, "SFA_ISSUER", "https://authjs.web3auth.io/jwks");
    defineProperty_default()(this, "status", base_namespaceObject.ADAPTER_STATUS.NOT_READY);
    defineProperty_default()(this, "authInstance", null);
    defineProperty_default()(this, "state", {});
    defineProperty_default()(this, "nodeDetails", null);
    defineProperty_default()(this, "torusPrivKey", null);
    defineProperty_default()(this, "privKeyProvider", null);
    defineProperty_default()(this, "accountAbstractionProvider", null);
    defineProperty_default()(this, "sessionManager", void 0);
    defineProperty_default()(this, "currentStorage", void 0);
    defineProperty_default()(this, "baseStorageKey", "sfa_store");
    defineProperty_default()(this, "sessionNamespace", "sfa");
    defineProperty_default()(this, "plugins", {});
    if (!options.clientId) throw base_namespaceObject.WalletInitializationError.invalidParams("Please provide a valid clientId in constructor");
    if (!options.privateKeyProvider) throw base_namespaceObject.WalletInitializationError.invalidParams("Please provide a valid privateKeyProvider in constructor");
    if ((_options$chainConfig = options.chainConfig) !== null && _options$chainConfig !== void 0 && _options$chainConfig.chainId && ((_options$privateKeyPr = options.privateKeyProvider.currentChainConfig) === null || _options$privateKeyPr === void 0 ? void 0 : _options$privateKeyPr.chainId) !== ((_options$chainConfig2 = options.chainConfig) === null || _options$chainConfig2 === void 0 ? void 0 : _options$chainConfig2.chainId)) {
      throw base_namespaceObject.WalletInitializationError.invalidParams("chainId in privateKeyProvider and chainConfig should be same");
    }
    this.coreOptions = objectSpread2_default()(objectSpread2_default()({}, options), {}, {
      web3AuthNetwork: options.web3AuthNetwork || auth_namespaceObject.WEB3AUTH_NETWORK.MAINNET,
      sessionTime: options.sessionTime || 86400,
      storageServerUrl: options.storageServerUrl || "https://session.web3auth.io",
      storageKey: options.storageKey || "local",
      chainConfig: options.chainConfig || options.privateKeyProvider.currentChainConfig,
      storage: this.getStorage(options.storage),
      mode: options.mode || SDK_MODE.WEB
    });
    this.coreOptions.useDkg = this.isSapphireNetwork() ? (_options$useDkg = options.useDkg) !== null && _options$useDkg !== void 0 ? _options$useDkg : true : true;
    this.privKeyProvider = options.privateKeyProvider;
    if (options.accountAbstractionProvider) {
      this.accountAbstractionProvider = options.accountAbstractionProvider;
    }
  }
  get connected() {
    return this.status === base_namespaceObject.ADAPTER_STATUS.CONNECTED;
  }
  get provider() {
    if (this.status !== base_namespaceObject.ADAPTER_STATUS.NOT_READY && this.privKeyProvider) {
      var _this$accountAbstract;
      return (_this$accountAbstract = this.accountAbstractionProvider) !== null && _this$accountAbstract !== void 0 ? _this$accountAbstract : this.privKeyProvider;
    }
    return null;
  }
  set provider(_) {
    throw new Error("Not implemented");
  }
  async init() {
    if (this.status !== base_namespaceObject.ADAPTER_STATUS.NOT_READY) throw base_namespaceObject.WalletInitializationError.notReady("Already initialized");
    if (!this.privKeyProvider.currentChainConfig || !this.privKeyProvider.currentChainConfig.chainNamespace || !this.privKeyProvider.currentChainConfig.chainId) {
      throw base_namespaceObject.WalletInitializationError.invalidParams("provider should have chainConfig and should be initialized with chainId and chainNamespace");
    }
    const storageKey = this.coreOptions.sessionKey || `${this.baseStorageKey}_${this.coreOptions.usePnPKey ? "pnp" : "core_kit"}`;
    this.currentStorage = new AsyncStorage(storageKey, this.coreOptions.storage);
    this.nodeDetails = (0,fnd_base_namespaceObject.fetchLocalConfig)(this.coreOptions.web3AuthNetwork, external_toruslabs_constants_namespaceObject.KEY_TYPE.SECP256K1);
    this.authInstance = new torus_js_namespaceObject.Torus({
      clientId: this.coreOptions.clientId,
      enableOneKey: true,
      network: this.coreOptions.web3AuthNetwork,
      serverTimeOffset: this.coreOptions.serverTimeOffset
    });
    const sessionId = await this.currentStorage.get("sessionId");
    this.sessionManager = new session_manager_namespaceObject.SessionManager({
      sessionServerBaseUrl: this.coreOptions.storageServerUrl,
      sessionTime: this.coreOptions.sessionTime,
      sessionNamespace: this.sessionNamespace,
      sessionId
    });
    this.subscribeToEvents();
    if (this.plugins[PASSKEYS_PLUGIN]) {
      await this.plugins[PASSKEYS_PLUGIN].initWithWeb3Auth(this);
    }

    // if sessionId exists in storage, then try to rehydrate session.
    if (sessionId) {
      // we are doing this to make sure sessionKey is set
      // before we call authorizeSession in both cjs and esm bundles.
      this.sessionManager.sessionId = sessionId;
      const data = await this.sessionManager.authorizeSession().catch(() => {
        this.currentStorage.set("sessionId", "");
      });
      if (data && data.privKey) {
        this.torusPrivKey = data.basePrivKey;
        const finalPrivKey = await this.getFinalPrivKey(data.basePrivKey);
        await this.privKeyProvider.setupProvider(finalPrivKey);
        // setup aa provider after private key provider is setup
        if (this.accountAbstractionProvider) {
          await this.accountAbstractionProvider.setupProvider(this.privKeyProvider);
        }
        this.updateState(data);
        this.status = base_namespaceObject.ADAPTER_STATUS.CONNECTED;
        this.emit(base_namespaceObject.ADAPTER_EVENTS.CONNECTED, {
          adapter: this.connectedAdapterName,
          provider: this.provider,
          reconnected: true
        });
      }
    }
    if (!this.state.privKey) {
      this.status = base_namespaceObject.ADAPTER_STATUS.READY;
      this.emit(base_namespaceObject.ADAPTER_EVENTS.READY, this.connectedAdapterName);
    }
  }
  async authenticateUser() {
    if (!this.connected) throw base_namespaceObject.WalletLoginError.notConnectedError();
    const {
      userInfo
    } = this.state;
    if (userInfo !== null && userInfo !== void 0 && userInfo.idToken) return {
      idToken: userInfo.idToken
    };
    const {
      chainNamespace,
      chainId
    } = this.coreOptions.chainConfig || {};
    if (!this.authInstance || !this.privKeyProvider) throw base_namespaceObject.WalletInitializationError.notReady();
    const [accounts, publicKey] = await Promise.all([this.privKeyProvider.provider.request({
      method: chainNamespace === base_namespaceObject.CHAIN_NAMESPACES.EIP155 ? "eth_accounts" : "getAccounts"
    }), this.privKeyProvider.provider.request({
      method: "public_key"
    })]);
    // const thresholdPrivKey = this._getBasePrivKey();

    if (accounts && accounts.length > 0) {
      const existingToken = (0,base_namespaceObject.getSavedToken)(accounts[0], "SFA");
      if (existingToken) {
        const isExpired = (0,base_namespaceObject.checkIfTokenIsExpired)(existingToken);
        if (!isExpired) {
          return {
            idToken: existingToken
          };
        }
      }
      const payload = {
        domain: typeof window !== "undefined" ? window.location.origin : "reactnative",
        uri: typeof window !== "undefined" ? window.location.href : "com://reactnative",
        address: accounts[0],
        chainId: parseInt(chainId, 16),
        version: "1",
        nonce: Math.random().toString(36).slice(2),
        issuedAt: new Date().toISOString()
      };
      const additionalMetadata = {
        email: userInfo.email,
        name: userInfo.name,
        profileImage: userInfo.profileImage,
        aggregateVerifier: userInfo.aggregateVerifier,
        verifier: userInfo.verifier,
        verifierId: userInfo.verifierId,
        typeOfLogin: userInfo.typeOfLogin || "jwt",
        oAuthIdToken: userInfo.oAuthIdToken,
        oAuthAccessToken: userInfo.oAuthAccessToken,
        wallets: [],
        signatures: this.state.signatures,
        network: this.coreOptions.web3AuthNetwork
      };
      if (this.coreOptions.usePnPKey) {
        additionalMetadata.wallets.push({
          public_key: publicKey,
          type: "web3auth_app_key",
          curve: chainNamespace === base_namespaceObject.CHAIN_NAMESPACES.EIP155 ? external_toruslabs_constants_namespaceObject.KEY_TYPE.SECP256K1 : external_toruslabs_constants_namespaceObject.KEY_TYPE.ED25519
        });
      } else {
        additionalMetadata.wallets.push({
          public_key: publicKey,
          type: "web3auth_threshold_key",
          curve: chainNamespace === base_namespaceObject.CHAIN_NAMESPACES.EIP155 ? external_toruslabs_constants_namespaceObject.KEY_TYPE.SECP256K1 : external_toruslabs_constants_namespaceObject.KEY_TYPE.ED25519
        });
      }
      const challenge = await (0,base_controllers_namespaceObject.signChallenge)(payload, chainNamespace);
      const signedMessage = await this._getSignedMessage(challenge, accounts, chainNamespace);
      const idToken = await (0,base_controllers_namespaceObject.verifySignedChallenge)(chainNamespace, signedMessage, challenge, this.SFA_ISSUER, this.coreOptions.sessionTime, this.coreOptions.clientId, this.coreOptions.web3AuthNetwork, undefined, additionalMetadata);
      (0,base_namespaceObject.saveToken)(accounts[0], "SFA", idToken);
      return {
        idToken
      };
    }
  }
  async addChain(chainConfig) {
    if (this.status === base_namespaceObject.ADAPTER_STATUS.NOT_READY) throw base_namespaceObject.WalletInitializationError.notReady("Please call init first.");
    return this.privKeyProvider.addChain(chainConfig);
  }
  switchChain(params) {
    if (this.status === base_namespaceObject.ADAPTER_STATUS.NOT_READY) throw base_namespaceObject.WalletInitializationError.notReady("Please call init first.");
    return this.privKeyProvider.switchChain(params);
  }
  async getPostboxKey(loginParams) {
    if (this.status === base_namespaceObject.ADAPTER_STATUS.NOT_READY) throw base_namespaceObject.WalletInitializationError.notReady("Please call init first.");
    return this.getTorusKey(loginParams);
  }

  /**
   * Use this function only with verifiers created on developer dashboard (https://dashboard.web3auth.io)
   * @param loginParams - Params used to login
   * @returns provider to connect
   */
  async connect(loginParams) {
    if (this.status === base_namespaceObject.ADAPTER_STATUS.CONNECTED) throw base_namespaceObject.WalletLoginError.connectionError("Already connected. Please check status before calling connect.");
    if (this.status !== base_namespaceObject.ADAPTER_STATUS.READY) throw base_namespaceObject.WalletInitializationError.notReady("Please call init first.");
    const {
      verifier,
      verifierId,
      idToken,
      subVerifierInfoArray
    } = loginParams;
    if (!verifier || !verifierId || !idToken) throw base_namespaceObject.WalletInitializationError.invalidParams("verifier or verifierId or idToken  required");
    const {
      torusNodeEndpoints,
      torusIndexes,
      torusNodePub
    } = this.nodeDetails;
    if (loginParams.serverTimeOffset) {
      this.authInstance.serverTimeOffset = loginParams.serverTimeOffset;
    }
    let finalIdToken = idToken;
    let finalVerifierParams = {
      verifier_id: verifierId
    };
    if (subVerifierInfoArray && (subVerifierInfoArray === null || subVerifierInfoArray === void 0 ? void 0 : subVerifierInfoArray.length) > 0) {
      const aggregateVerifierParams = {
        verify_params: [],
        sub_verifier_ids: [],
        verifier_id: ""
      };
      const aggregateIdTokenSeeds = [];
      for (let index = 0; index < subVerifierInfoArray.length; index += 1) {
        const userInfo = subVerifierInfoArray[index];
        aggregateVerifierParams.verify_params.push({
          verifier_id: verifierId,
          idtoken: userInfo.idToken
        });
        aggregateVerifierParams.sub_verifier_ids.push(userInfo.verifier);
        aggregateIdTokenSeeds.push(userInfo.idToken);
      }
      aggregateIdTokenSeeds.sort();
      finalIdToken = (0,torus_js_namespaceObject.keccak256)(Buffer.from(aggregateIdTokenSeeds.join(String.fromCharCode(29)), "utf8")).slice(2);
      aggregateVerifierParams.verifier_id = verifierId;
      finalVerifierParams = aggregateVerifierParams;
    }
    const retrieveSharesResponse = await this.authInstance.retrieveShares({
      endpoints: torusNodeEndpoints,
      indexes: torusIndexes,
      verifier,
      verifierParams: finalVerifierParams,
      idToken: finalIdToken,
      nodePubkeys: torusNodePub,
      checkCommitment: false,
      useDkg: this.coreOptions.useDkg,
      extraParams: {}
    });
    if (retrieveSharesResponse.metadata.upgraded) {
      throw base_namespaceObject.WalletLoginError.mfaEnabled();
    }
    const {
      finalKeyData,
      oAuthKeyData
    } = retrieveSharesResponse;
    const privKey = finalKeyData.privKey || oAuthKeyData.privKey;
    this.torusPrivKey = privKey;
    if (!privKey) throw base_namespaceObject.WalletLoginError.fromCode(5000, "Unable to get private key from torus nodes");

    // we are using the original private key so that we can retrieve other keys later on
    let decodedUserInfo;
    try {
      decodedUserInfo = decodeToken(idToken).payload;
    } catch (error) {
      decodedUserInfo = loginParams.fallbackUserInfo;
    }
    const userInfo = {
      name: decodedUserInfo.name || decodedUserInfo.nickname || "",
      email: decodedUserInfo.email || "",
      profileImage: decodedUserInfo.picture || "",
      verifierId,
      verifier,
      typeOfLogin: "jwt",
      oAuthIdToken: idToken
    };
    const signatures = this.getSessionSignatures(retrieveSharesResponse.sessionData);
    await this._finalizeLogin({
      privKey,
      userInfo,
      signatures
    });
    return this.provider;
  }
  async logout() {
    if (!this.connected) throw base_namespaceObject.WalletLoginError.notConnectedError("Not logged in");
    if (this.coreOptions.mode !== SDK_MODE.NODE) {
      await this.sessionManager.invalidateSession();
      this.currentStorage.set("sessionId", "");
    }
    this.updateState({
      privKey: "",
      userInfo: {
        name: "",
        email: "",
        profileImage: "",
        verifierId: "",
        verifier: "",
        typeOfLogin: ""
      }
    });
    this.status = base_namespaceObject.ADAPTER_STATUS.READY;
    this.emit(base_namespaceObject.ADAPTER_EVENTS.DISCONNECTED);
  }
  async getUserInfo() {
    if (!this.connected) throw base_namespaceObject.WalletLoginError.userNotLoggedIn();
    return this.state.userInfo;
  }
  addPlugin(plugin) {
    if (this.isRNOrNodeMode()) throw base_namespaceObject.WalletInitializationError.invalidParams("Plugins are not supported in this mode");
    if (this.plugins[plugin.name]) throw base_namespaceObject.WalletInitializationError.duplicateAdapterError(`Plugin ${plugin.name} already exist`);
    this.plugins[plugin.name] = plugin;
    if (this.status === base_namespaceObject.ADAPTER_STATUS.CONNECTED && this.connectedAdapterName) {
      // web3auth is already connected. can initialize plugins
      this.connectToPlugins();
    }
    if (plugin.name === PASSKEYS_PLUGIN && (this.status === base_namespaceObject.ADAPTER_STATUS.READY || this.status === base_namespaceObject.ADAPTER_STATUS.CONNECTED)) {
      // this does return a Promise but we don't need to wait here.
      // as its mostly a sync function.
      this.plugins[PASSKEYS_PLUGIN].initWithWeb3Auth(this);
    }
    return this;
  }
  getPlugin(name) {
    if (this.isRNOrNodeMode()) throw base_namespaceObject.WalletInitializationError.invalidParams("Plugins are not supported in this mode");
    return this.plugins[name] || null;
  }
  async _finalizeLogin(params) {
    const {
      privKey,
      signatures = [],
      passkeyToken = ""
    } = params;
    this.torusPrivKey = privKey;
    // update the provider with the private key.
    const finalPrivKey = await this.getFinalPrivKey(privKey);
    await this.privKeyProvider.setupProvider(finalPrivKey);
    // setup aa provider after private key provider is setup
    if (this.accountAbstractionProvider) {
      await this.accountAbstractionProvider.setupProvider(this.privKeyProvider);
    }

    // We only need to authenticate user in web mode.
    // This is for the passkey plugin mode only.
    if (this.coreOptions.mode === SDK_MODE.WEB) {
      const {
        idToken
      } = await this.authenticateUser().catch(_ => ({
        idToken: ""
      }));
      if (params.userInfo) {
        params.userInfo.idToken = idToken;
      } else {
        params.userInfo = {
          idToken
        };
      }
    }

    // We dont need to save the session in node mode.
    if (this.coreOptions.mode !== SDK_MODE.NODE) {
      // save the data in the session.
      const sessionId = session_manager_namespaceObject.SessionManager.generateRandomSessionKey();
      this.sessionManager.sessionId = sessionId;
      await this.sessionManager.createSession({
        basePrivKey: privKey,
        privKey: finalPrivKey,
        userInfo: params.userInfo,
        signatures,
        passkeyToken
      });
      this.currentStorage.set("sessionId", sessionId);
    }

    // update the local state.
    this.updateState({
      privKey: finalPrivKey,
      basePrivKey: privKey,
      userInfo: params.userInfo,
      signatures,
      passkeyToken
    });
    this.status = base_namespaceObject.ADAPTER_STATUS.CONNECTED;
    this.emit(base_namespaceObject.ADAPTER_EVENTS.CONNECTED, {
      adapter: this.connectedAdapterName,
      provider: this.provider,
      reconnected: false
    });
  }
  _getBasePrivKey() {
    return this.torusPrivKey;
  }
  updateState(newState) {
    this.state = objectSpread2_default()(objectSpread2_default()({}, this.state), newState);
  }
  async getFinalPrivKey(privKey) {
    let finalPrivKey = privKey.padStart(64, "0");
    // get app scoped keys.
    if (this.coreOptions.usePnPKey) {
      finalPrivKey = this.getSubKey(finalPrivKey);
    }
    if (this.coreOptions.chainConfig.chainNamespace === base_namespaceObject.CHAIN_NAMESPACES.SOLANA) {
      finalPrivKey = this.getEd25519Key(finalPrivKey);
    }
    return finalPrivKey;
  }
  getSubKey(privKey) {
    const pnpPrivKey = (0,auth_namespaceObject.subkey)(privKey, Buffer.from(this.coreOptions.clientId, "base64"));
    return pnpPrivKey.padStart(64, "0");
  }
  getEd25519Key(privKey) {
    if (!this.privKeyProvider.getEd25519Key) {
      throw base_namespaceObject.WalletLoginError.fromCode(5000, "Private key provider is not valid, Missing getEd25519Key function");
    }
    return this.privKeyProvider.getEd25519Key(privKey);
  }
  async getTorusKey(loginParams) {
    const {
      verifier,
      verifierId,
      idToken,
      subVerifierInfoArray
    } = loginParams;
    const {
      torusNodeEndpoints,
      torusIndexes,
      torusNodePub
    } = (0,fnd_base_namespaceObject.fetchLocalConfig)(this.coreOptions.web3AuthNetwork, external_toruslabs_constants_namespaceObject.KEY_TYPE.SECP256K1);
    if (loginParams.serverTimeOffset) {
      this.authInstance.serverTimeOffset = loginParams.serverTimeOffset;
    }
    let finalIdToken = idToken;
    let finalVerifierParams = {
      verifier_id: verifierId
    };
    if (subVerifierInfoArray && (subVerifierInfoArray === null || subVerifierInfoArray === void 0 ? void 0 : subVerifierInfoArray.length) > 0) {
      const aggregateVerifierParams = {
        verify_params: [],
        sub_verifier_ids: [],
        verifier_id: ""
      };
      const aggregateIdTokenSeeds = [];
      for (let index = 0; index < subVerifierInfoArray.length; index += 1) {
        const userInfo = subVerifierInfoArray[index];
        aggregateVerifierParams.verify_params.push({
          verifier_id: verifierId,
          idtoken: userInfo.idToken
        });
        aggregateVerifierParams.sub_verifier_ids.push(userInfo.verifier);
        aggregateIdTokenSeeds.push(userInfo.idToken);
      }
      aggregateIdTokenSeeds.sort();
      finalIdToken = (0,torus_js_namespaceObject.keccak256)(Buffer.from(aggregateIdTokenSeeds.join(String.fromCharCode(29)), "utf8")).slice(2);
      aggregateVerifierParams.verifier_id = verifierId;
      finalVerifierParams = aggregateVerifierParams;
    }
    const retrieveSharesResponse = await this.authInstance.retrieveShares({
      endpoints: torusNodeEndpoints,
      indexes: torusIndexes,
      verifier,
      verifierParams: finalVerifierParams,
      idToken: finalIdToken,
      useDkg: this.coreOptions.useDkg,
      checkCommitment: false,
      extraParams: {},
      nodePubkeys: torusNodePub
    });
    const postboxKey = torus_js_namespaceObject.Torus.getPostboxKey(retrieveSharesResponse);
    return postboxKey.padStart(64, "0");
  }
  isSapphireNetwork() {
    return Object.values(external_toruslabs_constants_namespaceObject.TORUS_SAPPHIRE_NETWORK).includes(this.coreOptions.web3AuthNetwork);
  }
  getSessionSignatures(sessionData) {
    return sessionData.sessionTokenData.filter(i => Boolean(i)).map(session => JSON.stringify({
      data: session.token,
      sig: session.signature
    }));
  }
  subscribeToEvents() {
    this.on(base_namespaceObject.ADAPTER_EVENTS.CONNECTED, async () => {
      this.connectToPlugins();
    });
    this.on(base_namespaceObject.ADAPTER_EVENTS.DISCONNECTED, async () => {
      const localPlugins = Object.values(this.plugins).filter(plugin => plugin.name !== PASSKEYS_PLUGIN);
      localPlugins.forEach(async plugin => {
        try {
          if (!plugin.SUPPORTED_ADAPTERS.includes(base_namespaceObject.WALLET_ADAPTERS.SFA)) {
            return;
          }
          await plugin.disconnect();
        } catch (error) {
          // swallow error if connector adapter doesn't supports this plugin.
          if (error.code === 5211) {
            return;
          }
          base_namespaceObject.log.error(error);
        }
      });
    });
  }
  connectToPlugins() {
    const localPlugins = Object.values(this.plugins).filter(plugin => plugin.name !== PASSKEYS_PLUGIN);
    localPlugins.forEach(async plugin => {
      try {
        if (!plugin.SUPPORTED_ADAPTERS.includes(base_namespaceObject.WALLET_ADAPTERS.SFA)) {
          return;
        }
        if (plugin.status === base_namespaceObject.PLUGIN_STATUS.CONNECTED) return;
        await plugin.initWithWeb3Auth(this);
        await plugin.connect({
          sessionId: this.sessionManager.sessionId,
          sessionNamespace: this.sessionNamespace
        });
      } catch (error) {
        // swallow error if connector adapter doesn't supports this plugin.
        if (error.code === 5211) {
          return;
        }
        base_namespaceObject.log.error(error);
      }
    });
  }
  async _getSignedMessage(challenge, accounts, chainNamespace) {
    const signedMessage = await this.privKeyProvider.provider.request({
      method: chainNamespace === base_namespaceObject.CHAIN_NAMESPACES.EIP155 ? "personal_sign" : "signMessage",
      params: chainNamespace === base_namespaceObject.CHAIN_NAMESPACES.EIP155 ? [challenge, accounts[0]] : {
        message: Buffer.from(challenge)
      }
    });
    if (chainNamespace === base_namespaceObject.CHAIN_NAMESPACES.SOLANA) return external_bs58_default().encode(signedMessage);
    return signedMessage;
  }
  isRNOrNodeMode() {
    return this.coreOptions.mode === SDK_MODE.REACT_NATIVE || this.coreOptions.mode === SDK_MODE.NODE;
  }
  getStorage(storage) {
    if (typeof window !== "undefined") {
      if (!storage || storage === "local") return window.localStorage;
      if (storage === "session") return window.sessionStorage;
    } else if (!storage || typeof storage === "string") return new auth_namespaceObject.MemoryStore();
    return storage;
  }
}
;// ./src/index.ts





module.exports = __webpack_exports__;
/******/ })()
;