import { IStorage } from "@web3auth/auth";
import { IAsyncStorage, ISecureStore } from "./interface";
export declare class AsyncStorage {
    storage: IAsyncStorage | IStorage | ISecureStore;
    private _storeKey;
    constructor(storeKey: string, storage: IAsyncStorage | IStorage | ISecureStore);
    toJSON(): Promise<string>;
    resetStore(): Promise<Record<string, unknown>>;
    getStore(): Promise<Record<string, unknown>>;
    setStore(store: Record<string, unknown>): Promise<void>;
    get<T>(key: string): Promise<T>;
    set<T>(key: string, value: T): Promise<void>;
    remove(key: string): Promise<void>;
}
